<?php

namespace SM\Controller;

use SM\Util\Utilities;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO\Response;
use SM\Service\Sm00005000TabParametrizacoesIndicesPadroesService;
use SM\Traits\TResponse;

class Sm00005000TabParametrizacoesIndicesPadroesController
{
    use TResponse;

    protected $parametrizacaoIndiceService;

    public function __construct(Sm00005000TabParametrizacoesIndicesPadroesService $parametrizacaoIndiceService)
    {
        $this->parametrizacaoIndiceService = $parametrizacaoIndiceService;
    }

    public function getIndicesPadroes()
    {
        try {
            $data = $this->parametrizacaoIndiceService->getIndicesPadroes();
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function getIndiceFinanceiro()
    {
        try {
            $data = $this->parametrizacaoIndiceService->getIndiceFinanceiro();
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function saveIndicesFinanceirosPadrao(Request $request)
    {
        try {
            $data = $this->parametrizacaoIndiceService->saveIndicesFinanceirosPadrao($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function deleteParametrosIndice(Request $request)
    {
        try {
            $data = $this->parametrizacaoIndiceService->deleteParametrosIndice($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }
}
