<?php

namespace SM\Controller;

use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO\Response;
use SM\Service\Sm00006001TabelaPrecoServicoService;
use SM\Traits\TResponse;

class Sm00006001TabelaPrecoServicoController
{
    use TResponse;
    protected $tabelaPrecoServicoService;

    public function __construct(Sm00006001TabelaPrecoServicoService $tabelaPrecoServicoService)
    {
        $this->tabelaPrecoServicoService = $tabelaPrecoServicoService;
    }

    public function getTabelaPrecoServicoGrid()
    {
        try {
            $data = $this->tabelaPrecoServicoService->getTabelaPrecoServicoGrid();
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function getServicosTabelaPreco(Request $request)
    {
        try {
            $data = $this->tabelaPrecoServicoService->getServicosTabelaPreco($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function salvarTabelaPreco(Request $request)
    {
        try {
            $data = $this->tabelaPrecoServicoService->salvarTabelaPreco($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function deleteTabelaPrecoServico(Request $request)
    {
        try {
            $data = $this->tabelaPrecoServicoService->deleteTabelaPrecoServico($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function copiaOutraMoeda(Request $request)
    {
        try {
            $data = $this->tabelaPrecoServicoService->copiaOutraMoeda($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function validaServicoTabela(Request $request)
    {
        try {
            $data = $this->tabelaPrecoServicoService->validaServicoTabela($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function salvarServicoTabela(Request $request)
    {
        try {
            $data = $this->tabelaPrecoServicoService->salvarServicoTabela($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function sincronizarVariacaoPreco(Request $request)
    {
        try {
            $this->tabelaPrecoServicoService->executarProcedureFctSincronizarVariacaoPreco($request->getParameters());
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function deleteServicosTabelaPrecoServico(Request $request)
    {
        try {
            $data = $this->tabelaPrecoServicoService->deleteServicosTabelaPrecoServico($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function getMedidaVariavelTabelaPreco(Request $request)
    {
        try {
            $data = $this->tabelaPrecoServicoService->getMedidaVariavelTabelaPreco($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function validaFranquiaFaixa(Request $request)
    {
        try {
            $data = $this->tabelaPrecoServicoService->validaFranquiaFaixa($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function insereVariacaoPreco(Request $request)
    {
        try {
            $data = $this->tabelaPrecoServicoService->insereVariacaoPreco($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function updateVariacao(Request $request)
    {
        try {
            $data = $this->tabelaPrecoServicoService->updateVariacao($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function deleteServicosTabelaPrecoMedidaVariavel(Request $request)
    {
        try {
            $data = $this->tabelaPrecoServicoService->deleteServicosTabelaPrecoMedidaVariavel($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function getVariacaoPrecoTabelaPreco(Request $request)
    {
        try {
            $data = $this->tabelaPrecoServicoService->getVariacaoPrecoTabelaPreco($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function validaTipoMedidaVariavel(Request $request)
    {
        try {
            $data = $this->tabelaPrecoServicoService->validaTipoMedidaVariavel($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function salvarVariacaoTipoDeMedida(Request $request)
    {
        try {
            $data = $this->tabelaPrecoServicoService->salvarVariacaoTipoDeMedida($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }
}
