-- Sistemas Integrados TEKNISA
-- Faturamento de Servios
--
-- Nome: 0004_CVIVIEO_ETL_HORAS_APROPRIADA.SQL
--
-- Descrio:
-- Permite visualizar as horas trabalhadas, as horas apropriadas e as horas no apropriadas de um funcionrio, por dia.
-- Os dados sero utilizados no CoreVision para encontrar o % de disponibilidade de cada funcionrio em um determinado perodo.
--
-- Criao:
-- 09/02/2011 - Tarcsio Dias Pereira

CREATE VIEW ETL_HORAS_APROPRIADA AS
SELECT NMFUNC, NMEQUIPETRAB, DSANOMESPONTO, DSANOMESDIAPONTO, ANPONTO, DSPERIODOPONTO,
       QTHRTRABALHADAS, QTHRAPROPRIADAS, (QTHRTRABALHADAS - QTHRAPROPRIADAS) QTHRNAOAPROPRIADAS
  FROM (SELECT FU.NMFUNC||' - '||FU.CDFUNC NMFUNC, EQ.NMEQUIPETRAB,
               TO_CHAR(AP.DTAPONT, 'YYYY/MM') DSANOMESPONTO, TO_CHAR(AP.DTAPONT, 'YYYY/MM/DD') DSANOMESDIAPONTO, TO_CHAR(AP.DTAPONT, 'YYYY') ANPONTO,
               CASE WHEN (TO_CHAR(AP.DTAPONT, 'DD') >= '21') AND (TO_CHAR(AP.DTAPONT, 'DD') <= '31') 
                    THEN TO_CHAR(TO_DATE('21/'||TO_CHAR(AP.DTAPONT, 'MM/YYYY')), 'DD/MM/YYYY')||' a '|| 
                         TO_CHAR(ADD_MONTHS(TO_DATE('20/'||TO_CHAR(AP.DTAPONT, 'MM/YYYY')), 1), 'DD/MM/YYYY')
                    ELSE TO_CHAR(ADD_MONTHS(TO_DATE('21/'||TO_CHAR(AP.DTAPONT, 'MM/YYYY')), -1), 'DD/MM/YYYY')||' a '|| 
                         TO_CHAR(TO_DATE('20/'||TO_CHAR(AP.DTAPONT, 'MM/YYYY')), 'DD/MM/YYYY')
               END AS DSPERIODOPONTO,                
               NVL((((NVL(AP.HRSAIREFE, AP.DTAPONT) - NVL(AP.HRENTREAL, AP.DTAPONT)) + (NVL(AP.HRSAIREAL, AP.DTAPONT) - NVL(AP.HRRETREFE, AP.DTAPONT)))*24) - (TO_NUMBER(SUBSTR(HRAUSENCIA,1,2))+(TO_NUMBER(SUBSTR(HRAUSENCIA,3,2))/60)),0) QTHRTRABALHADAS,
               (NVL(TAR.QTHRAPROATIVTARE, 0) + NVL(CSA.QTHRAPROATIVCSA, 0)) AS QTHRAPROPRIADAS
          FROM (SELECT OPE.CDEMPRESA, OPE.CDFUNC, TAR.DTAPROATIVTARE, TAR.NRORG, 
                       SUM((TAR.DTFAPATIVTAR - TAR.DTIAPATIVTAR) * 24) QTHRAPROATIVTARE
                  FROM OPERADOR OPE, APROATIVTARE TAR
                 WHERE TAR.DTAPROATIVTARE >= '01/01/2010'
                   AND NOT EXISTS (SELECT *
                                     FROM APROATIVCSA CSA
                                    WHERE ((TAR.DTIAPATIVTAR BETWEEN CSA.DTHRINIAPROCSA AND CSA.DTHRFIMAPROCSA) 
                                        OR (TAR.DTFAPATIVTAR BETWEEN CSA.DTHRINIAPROCSA AND CSA.DTHRFIMAPROCSA))
                                      AND CSA.CDEMPRESA = OPE.CDEMPRESA
                                      AND CSA.CDFUNC = OPE.CDFUNC 
                                      AND CSA.DTSERVPREST = TAR.DTAPROATIVTARE
                                      AND CSA.NRORG = TAR.NRORG)
                   AND OPE.CDOPERADOR = TAR.CDOPERADOR
                   AND OPE.NRORG = TAR.NRORG
                 GROUP BY OPE.CDEMPRESA, OPE.CDFUNC, TAR.DTAPROATIVTARE, TAR.NRORG) TAR, 
               (SELECT CSA.CDEMPRESA, CSA.CDFUNC, CSA.DTSERVPREST, CSA.NRORG,
                       SUM((CSA.DTHRFIMAPROCSA - CSA.DTHRINIAPROCSA) * 24) QTHRAPROATIVCSA
                  FROM ATIVGERALCSA ATG, APROATIVCSA CSA
                 WHERE CSA.DTSERVPREST >= '01/01/2010'
                   AND ATG.CDATIVGERALCSA = CSA.CDATIVGERALCSA
                   AND ATG.NRORG = CSA.NRORG
                   AND ATG.IDATIVGERALCSA = 'O'
                 GROUP BY CSA.CDEMPRESA, CSA.CDFUNC, CSA.DTSERVPREST, CSA.NRORG) CSA,
               APONTAMENTO AP, EQUIPETRAB EQ, FUNCIONARIO FU                  
         WHERE AP.CDEMPRESA = '01'
           AND AP.DTAPONT >= '01/01/2010'
           AND AP.NRORG = 1
           AND FU.CDEMPRESA = AP.CDEMPRESA
           AND FU.CDFUNC = AP.CDFUNC
           AND FU.NRORG = AP.NRORG
           AND EQ.CDEQUIPETRAB = FU.CDEQUIPETRAB
           AND EQ.NRORG = AP.NRORG
           AND TAR.CDEMPRESA (+) = AP.CDEMPRESA
           AND TAR.CDFUNC(+) = AP.CDFUNC
           AND TAR.DTAPROATIVTARE (+) = AP.DTAPONT
           AND TAR.NRORG (+) = AP.NRORG
           AND CSA.CDEMPRESA (+) = AP.CDEMPRESA
           AND CSA.CDFUNC (+) = AP.CDFUNC
           AND CSA.DTSERVPREST (+) = AP.DTAPONT
           AND CSA.NRORG (+) = AP.NRORG)
 WHERE QTHRTRABALHADAS <> 0 
    OR QTHRAPROPRIADAS <> 0          
/

-- VERSAO --
BEGIN ATUVEROBJ('ETL_HORAS_APROPRIADA','5.20.003'); END;
/
