/* eslint-disable */
import { Utilities } from '@/util/Utilities';
import {
    Form, LoadingService, Select, Number, TextInput, Password,
} from '@zeedhi/common';
import {
    Http, Metadata,
} from '@zeedhi/core';

export class Sm00005000TabParametrizacoesServicesController {
    public clickButtonToExpand({ component }: any) {
        const form = Metadata.getInstance<Form>(component.name.split('_')[1]);
        form.isVisible = !form.isVisible;

        component.iconName = (component.iconName === 'mdi-chevron-down') ? 'mdi-chevron-right' : 'mdi-chevron-down';
    }

    public setDadosFormParametrizacao() {
        LoadingService.show();
        Http.get('/getParametrosGeral', {
        }).then((retorno) => {
            Metadata.getInstance<Select>('formParametrosGerais-IDUTILIZAHIEROPER').value = retorno.data.data[0].IDUTILIZAHIEROPER;
            Metadata.getInstance<Select>('formParametrosGerais-IDVALIDACPFRF').value = retorno.data.data[0].IDVALIDACPFRF;
            Metadata.getInstance<Select>('formParametrosProposta-IDOBRIGMODORC').value = retorno.data.data[0].IDOBRIGMODORC;
            Metadata.getInstance<Select>('formParametrosProposta-IDCONVCLIENTE').value = retorno.data.data[0].IDCONVCLIENTE;
            Metadata.getInstance<TextInput>('formParametrosProposta-NRINISEQCODORCA').value = retorno.data.data[0].NRINISEQCODORCA;
            Metadata.getInstance<Select>('formParametrosProposta-IDALTERAPROPCONC').value = retorno.data.data[0].IDALTERAPROPCONC;
            const nmPerfilAcessPro = this.converteArrayOfNumber(retorno.data.data[0].FCT_ALTPROPCONCPERF);
            Metadata.getInstance<Select>('formParametrosProposta-NMPERFILACESSO').value = nmPerfilAcessPro;
            Metadata.getInstance<TextInput>('formParametrosContrato-NRINISEQCODCONT').value = retorno.data.data[0].NRINISEQCODCONT;
            Metadata.getInstance<Select>('formParametrosContrato-IDALTERACONTAPROV').value = retorno.data.data[0].IDALTERACONTAPROV;
            const nmPerfilAcessCont = this.converteArrayOfNumber(retorno.data.data[0].FCT_ALTCONTRAPROVPERF);
            Metadata.getInstance<Select>('formParametrosContrato-NMPERFILACESSO').value = nmPerfilAcessCont;
            Metadata.getInstance<Select>('formParametrosContrato-IDBUSCADTVENCNF').value = retorno.data.data[0].IDBUSCADTVENCNF;
            Metadata.getInstance<TextInput>('formParametrosRenovacaoContrato-DSEMAILALERTRENOVCONT').value = retorno.data.data[0].DSEMAILALERTRENOVCONT;
            Metadata.getInstance<Select>('formParametrosRenovacaoContrato-IDPERIODALERTRENOVCONT').value = retorno.data.data[0].IDPERIODALERTRENOVCONT;
            Metadata.getInstance<Select>('formParametrosReajusteContrato-IDBLOQREAJSEMALIQ').value = retorno.data.data[0].IDBLOQREAJSEMALIQ;
            Metadata.getInstance<Select>('formParametrosReajusteContrato-IDBLOQAPURFATSEMREAJ').value = retorno.data.data[0].IDBLOQAPURFATSEMREAJ;
            Metadata.getInstance<TextInput>('formConfEmail-DSHOSTEMAIL').value = retorno.data.data[0].DSHOSTEMAIL;
            Metadata.getInstance<TextInput>('formConfEmail-DSPORTAEMAIL').value = retorno.data.data[0].DSPORTAEMAIL;
            Metadata.getInstance<TextInput>('formConfEmail-DSUSUARIOEMAIL').value = retorno.data.data[0].DSUSUARIOEMAIL;
            Metadata.getInstance<Password>('formConfEmail-DSSENHAEMAIL').value = retorno.data.data[0].DSSENHAEMAIL;
            Metadata.getInstance<Select>('formConfEmail-IDSMTPSECURE').value = retorno.data.data[0].IDSMTPSECURE;
            Metadata.getInstance<TextInput>('formIntegracaoFacilities-DSURLINTEGRACAOFM').value = retorno.data.data[0].DSURLINTEGRACAOFM;
            Metadata.getInstance<TextInput>('formIntegracaoFacilities-NRTIPOLOCALCLIFM').value = retorno.data.data[0].NRTIPOLOCALCLIFM;
            Metadata.getInstance<TextInput>('formIntegracaoAssinatura-DSTOKENCERTSIGN').value = retorno.data.data[0].DSTOKENCERTSIGN;
            Metadata.getInstance<TextInput>('formIntegracaoAssinatura-NMSENDERCERTSIGN').value = retorno.data.data[0].NMSENDERCERTSIGN;
            Metadata.getInstance<TextInput>('formIntegracaoAssinatura-DSEMAILSENDERCERTSIGN').value = retorno.data.data[0].DSEMAILSENDERCERTSIGN;
            Metadata.getInstance<TextInput>('formIntegracaoAssinatura-NRCPFSENDERCERTSIGN').value = retorno.data.data[0].NRCPFSENDERCERTSIGN;
            Metadata.getInstance<Select>('formIntegracaoAssinatura-IDPADRAOASSINACERTSIGN').value = retorno.data.data[0].IDPADRAOASSINACERTSIGN;
            Metadata.getInstance<TextInput>('formIntegracaoAssinatura-NRTIPODOCCERTSIGN').value = retorno.data.data[0].NRTIPODOCCERTSIGN;
            Metadata.getInstance<TextInput>('formIntegracaoERP-URLINTEGRACAOERPFILIAL').value = retorno.data.data[0].URLINTEGRACAOERPFILIAL;
            Metadata.getInstance<TextInput>('formIntegracaoERP-NRTIPOLOCALCLIFM').value = retorno.data.data[0].NRTIPOLOCALCLIFM;
            Metadata.getInstance<TextInput>('formIntegracaoERP-NRTIPODOCCERTSIGN').value = retorno.data.data[0].NRTIPODOCCERTSIGN;
        }).catch((error) => {
            Utilities.showErrorMessage(error);
        }).finally(() => {
            LoadingService.hide();
        });
    }

    public converteArrayOfNumber(array: any) {
        const stringArray = array;
        const numberArray = [];
        for (let i = 0; i < stringArray.length; i += 1) {
            numberArray.push(parseInt(stringArray[i]));
        }
        return numberArray;
    }

    public validaParameterServico() {
        LoadingService.show();
        const novoCodigoProposta = Metadata.getInstance<Number>('formParametrosProposta-NRINISEQCODORCA').value;
        const novoCodigoContrato = Metadata.getInstance<Number>('formParametrosContrato-NRINISEQCODCONT').value;
        let cdContador = '';
        if (novoCodigoProposta != null) {
            const novoCodigo = Metadata.getInstance<Number>('formParametrosProposta-NRINISEQCODORCA').value;
            cdContador = 'FCT_ORCAMENTOCD';
            Http.post('/buscaNovoCodigo', {
                novoCodigo,
                cdContador,
            }).then((retorno) => {
                if (retorno.data.data.length > 0) {
                    const sequencial = retorno.data.data[0].NRSEQUENCIAL;
                    if (sequencial < novoCodigoProposta) {
                        const result = this.atualizaNovoCodigo(cdContador, novoCodigo);
                        if (result) {
                            this.saveperfilacesso();
                        }
                    } else {
                        Utilities.showDialogMessage('error', 'Operação Bloqueada!', `Sequencial atual da Proposta é maior do que o sequencial informado: ${sequencial}`);
                    }
                } else {
                    this.insereNovoCodigo(cdContador, novoCodigo);
                }
            }).catch((error) => {
                Utilities.showErrorMessage(error);
            });
        }
        if (novoCodigoContrato != null) {
            cdContador = 'FCT_CONTRATOCD';
            const novoCodigo = Metadata.getInstance<Number>('formParametrosContrato-NRINISEQCODCONT').value;
            Http.post('/buscaNovoCodigo', {
                novoCodigo,
                cdContador,
            }).then((retorno) => {
                if (retorno.data.data.length > 0) {
                    const sequencial = retorno.data.data[0].NRSEQUENCIAL;
                    if (sequencial < novoCodigoContrato) {
                        this.atualizaNovoCodigo(cdContador, novoCodigo);
                    } else {
                        Utilities.showDialogMessage('error', 'Operação Bloqueada!', `Sequencial atual da Proposta é maior do que o sequencial informado: ${sequencial}`);
                    }
                } else {
                    this.insereNovoCodigo(cdContador, novoCodigo);
                }
            }).catch((error) => {
                Utilities.showErrorMessage(error);
            });
        }
        this.saveperfilacesso();
    }

    public atualizaNovoCodigo(cdContador: any, novoCodigo: any) {
        const params = {
            cdContador,
            novoCodigo,
        };
        Http.post('/atualizaNovoCodigo', {
            params,
        }).then(() => true)
            .catch((error) => {
                Utilities.showErrorMessage(error);
            });
        return false;
    }

    public insereNovoCodigo(cdContador: any, novoCodigo: any) {
        const params = {
            cdContador,
            novoCodigo,
        };
        Http.post('/insereNovoCodigo', {
            params,
        }).then(() => {
            this.saveperfilacesso();
        }).catch((error) => {
            Utilities.showErrorMessage(error);
        });
    }

    public saveperfilacesso() {
        Http.post('/saveperfilacesso', {
            NRPERFILACESSOPROPOSTA: Metadata.getInstance<Select>('formParametrosProposta-NMPERFILACESSO').value,
            NRPERFILACESSOCONTRATO: Metadata.getInstance<Select>('formParametrosContrato-NMPERFILACESSO').value,
        }).then(() => {
            this.saveDadosParametrosService();
        }).catch((error) => {
            Utilities.showErrorMessage(error);
        }).finally(() => {
            LoadingService.hide();
        });
    }

    public saveDadosParametrosService() {
        const data = {
            IDUTILIZAHIEROPER: Metadata.getInstance<Select>('formParametrosGerais-IDUTILIZAHIEROPER').value,
            IDVALIDACPFRF: Metadata.getInstance<Select>('formParametrosGerais-IDVALIDACPFRF').value,
            IDOBRIGMODORC: Metadata.getInstance<Select>('formParametrosProposta-IDOBRIGMODORC').value,
            IDCONVCLIENTE: Metadata.getInstance<Select>('formParametrosProposta-IDCONVCLIENTE').value,
            NRINISEQCODORCA: Metadata.getInstance<TextInput>('formParametrosProposta-NRINISEQCODORCA').value,
            IDALTERAPROPCONC: Metadata.getInstance<Select>('formParametrosProposta-IDALTERAPROPCONC').value,
            NRPERFILACESSOPROPOSTA: Metadata.getInstance<Select>('formParametrosProposta-NMPERFILACESSO').value,
            NRINISEQCODCONT: Metadata.getInstance<TextInput>('formParametrosContrato-NRINISEQCODCONT').value,
            IDALTERACONTAPROV: Metadata.getInstance<Select>('formParametrosContrato-IDALTERACONTAPROV').value,
            NRPERFILACESSOCONTRATO: Metadata.getInstance<Select>('formParametrosContrato-NMPERFILACESSO').value,
            IDBUSCADTVENCNF: Metadata.getInstance<Select>('formParametrosContrato-IDBUSCADTVENCNF').value,
            DSEMAILALERTRENOVCONT: Metadata.getInstance<TextInput>('formParametrosRenovacaoContrato-DSEMAILALERTRENOVCONT').value,
            IDPERIODALERTRENOVCONT: Metadata.getInstance<Select>('formParametrosRenovacaoContrato-IDPERIODALERTRENOVCONT').value,
            IDBLOQREAJSEMALIQ: Metadata.getInstance<Select>('formParametrosReajusteContrato-IDBLOQREAJSEMALIQ').value,
            IDBLOQAPURFATSEMREAJ: Metadata.getInstance<Select>('formParametrosReajusteContrato-IDBLOQAPURFATSEMREAJ').value,
            DSHOSTEMAIL: Metadata.getInstance<TextInput>('formConfEmail-DSHOSTEMAIL').value,
            DSPORTAEMAIL: Metadata.getInstance<TextInput>('formConfEmail-DSPORTAEMAIL').value,
            DSUSUARIOEMAIL: Metadata.getInstance<TextInput>('formConfEmail-DSUSUARIOEMAIL').value,
            DSSENHAEMAIL: Metadata.getInstance<Password>('formConfEmail-DSSENHAEMAIL').value,
            IDSMTPSECURE: Metadata.getInstance<Select>('formConfEmail-IDSMTPSECURE').value,
            DSURLINTEGRACAOFM: Metadata.getInstance<TextInput>('formIntegracaoFacilities-DSURLINTEGRACAOFM').value,
            NRTIPOLOCALCLIFM: Metadata.getInstance<TextInput>('formIntegracaoFacilities-NRTIPOLOCALCLIFM').value,
            DSTOKENCERTSIGN: Metadata.getInstance<TextInput>('formIntegracaoAssinatura-DSTOKENCERTSIGN').value,
            NMSENDERCERTSIGN: Metadata.getInstance<TextInput>('formIntegracaoAssinatura-NMSENDERCERTSIGN').value,
            DSEMAILSENDERCERTSIGN: Metadata.getInstance<TextInput>('formIntegracaoAssinatura-DSEMAILSENDERCERTSIGN').value,
            NRCPFSENDERCERTSIGN: Metadata.getInstance<TextInput>('formIntegracaoAssinatura-NRCPFSENDERCERTSIGN').value,
            IDPADRAOASSINACERTSIGN: Metadata.getInstance<Select>('formIntegracaoAssinatura-IDPADRAOASSINACERTSIGN').value,
            NRTIPODOCCERTSIGN: Metadata.getInstance<TextInput>('formIntegracaoAssinatura-NRTIPODOCCERTSIGN').value,
            URLINTEGRACAOERPFILIAL: Metadata.getInstance<TextInput>('formIntegracaoERP-URLINTEGRACAOERPFILIAL').value,
        };
        console.warn(data);
        Http.post('/saveDadosParametrosService', {
            data,
        }).then(() => {
            this.setDadosFormParametrizacao();
            Utilities.showSuccessMessage();
        }).catch((error) => {
            Utilities.showErrorMessage(error);
        }).finally(() => {
            LoadingService.hide();
        });
    }
}
